<?php

namespace Ardent\GrocyApi\Objects;

class ShoppingListObject extends AbstractApiObject
{
    private int $product_id;

    private ?string $note;

    private int $amount;

    private string $row_created_timestamp;

    private int $shopping_list_id;

    private int $done;

    private int $qu_id;

    public static function getEntity(): string
    {
        return 'shopping_list';
    }

    /**
     * @return int
     */
    public function getProductId(): int
    {
        return $this->product_id;
    }

    /**
     * @param int $product_id
     *
     * @return ShoppingListObject
     */
    public function setProductId(int $product_id): ShoppingListObject
    {
        $this->product_id = $product_id;
        return $this;
    }

    /**
     * @return string|null
     */
    public function getNote(): ?string
    {
        return $this->note;
    }

    /**
     * @param string|null $note
     *
     * @return ShoppingListObject
     */
    public function setNote(?string $note): ShoppingListObject
    {
        $this->note = $note;
        return $this;
    }

    /**
     * @return int
     */
    public function getAmount(): int
    {
        return $this->amount;
    }

    /**
     * @param int $amount
     *
     * @return ShoppingListObject
     */
    public function setAmount(int $amount): ShoppingListObject
    {
        $this->amount = $amount;
        return $this;
    }

    /**
     * @return string
     */
    public function getRowCreatedTimestamp(): string
    {
        return $this->row_created_timestamp;
    }

    /**
     * @param string $row_created_timestamp
     *
     * @return ShoppingListObject
     */
    public function setRowCreatedTimestamp(string $row_created_timestamp): ShoppingListObject
    {
        $this->row_created_timestamp = $row_created_timestamp;
        return $this;
    }

    /**
     * @return int
     */
    public function getShoppingListId(): int
    {
        return $this->shopping_list_id;
    }

    /**
     * @param int $shopping_list_id
     *
     * @return ShoppingListObject
     */
    public function setShoppingListId(int $shopping_list_id): ShoppingListObject
    {
        $this->shopping_list_id = $shopping_list_id;
        return $this;
    }

    /**
     * @return int
     */
    public function getDone(): int
    {
        return $this->done;
    }

    /**
     * @param int $done
     *
     * @return ShoppingListObject
     */
    public function setDone(int $done): ShoppingListObject
    {
        $this->done = $done;
        return $this;
    }

    /**
     * @return int
     */
    public function getQuId(): int
    {
        return $this->qu_id;
    }

    /**
     * @param int $qu_id
     *
     * @return ShoppingListObject
     */
    public function setQuId(int $qu_id): ShoppingListObject
    {
        $this->qu_id = $qu_id;
        return $this;
    }
}